#ifndef LOGKEEPER_HPP
#define LOGKEEPER_HPP

#include "csvparser.hpp"
#include <CAN_IDs.h>
#include <LogReplay/Exceptions/LogFileNotOpenException.hpp>
#include <LogReplay/Exceptions/LogFileNotSupportedException.hpp>
#include <QFile>
#include <QObject>
#include <QTextStream>
#include <QTimer>
#include <QVector>

class LogKeeper : public QObject {
    Q_OBJECT
public:
    /**
     * @brief LogKeeper - Construtor.
     * @param logFileName - Log file name.
     */
    LogKeeper(QString logFileName);

    /**
     * @brief LogKeeper - Constructor
     */
    LogKeeper();

    ~LogKeeper();

    /**
     * @brief startLogReplay - Starts the log Replay.
     */
    void startLogReplay();

    /**
     * @brief stopLogReplay - Stops the log replay.
     */
    void stopLogReplay();

    /**
     * @brief parseLog - Parses the log file.
     */
    virtual void parseLog();

    /**
     * @brief parseDefaultCanMsg - Default parsing for log file line
     * @param list - log file line (Stringlist)
     * @return CANMsg generated by the line of the log file
     */
    CANmessage parseDefaultCanMsg(QStringList list);

    /**
     * @brief  parseCSVCanMsg - CSV parsing for log file line
     * @param list - log file line (Stringlist)
     * @return CANMsg generated by the line of the log file
     */
    CANmessage parseCSVCanMsg(QStringList list);

    /**
     * @brief setNewProgress - Sets a new progress to the log processing. Use this to got back and forth in the log.
     * @param percentage - New percentage value.
     */
    virtual void setNewProgress(float percentage) = 0;

    /**
     * @brief getTotalTime - Returns the total time of the log.
     * @return Total time.
     */
    ulong getTotalTime();

    void setFileName(QString fileName);

    /**
     * @brief getFileName -  Returns the file name of the log that is currently selected.
     * @return Name of the file.
     */
    QString getFileName();

    /**
     * @brief setSpeed - Sets a new speed for the log file to be parsed at.
     * @param speedValue - New speed value.
     */
    void setSpeed(float speedValue);

    /**
     * @brief getSpeed - Returns the current speed at which the current log is being processed.
     * @return Current speed value
     */
    float getSpeed();

    /**
     * @brief increaseSpeed - Increases speed to the next lower speed step.
     */
    void increaseSpeed();

    /**
     * @brief decreaseSpeed - Decreases speed to the next lower speed step.
     */
    void decreaseSpeed();

private:
    QString _logFileName;

    ulong _currentDataIndex;
    ulong _totalTime;
    QTimer* _timer;
    float _progress;
    float _speed;

private slots:

    void sendNewMessage();
    ulong calculateNextWaitingTime();
    void wait(ulong waitTime);

    void init();
    virtual void recalculateIndex(float percentage) = 0;
    virtual float calculatePercentage() = 0;
    virtual void recalculateProgress() = 0;

protected:
    /**
     * @brief _times - Vector with all the timestamps
     */
    QVector<ulong>* _times;

    /**
     * @brief _messages - Vector with all the CAN Messages.
     */
    QVector<CANmessage>* _messages;
protected slots:
    /**
     * @brief setProgress - Set a new progress for the current log.
     * @param percentage -  New progress value
     */
    void setProgress(float percentage);
    ulong getCurrentIndex();
    void setNewCurrentIndex(ulong newIndex);
signals:
    /**
     * @brief newMessage - Signal that is emitted when a new message is sent by the LogKeeper.
     * @param newPercentage - New progress percentage.
     * @param message - Message to be sent.
     */
    void newMessage(float newPercentage, CANmessage message);
};

#endif // LOGKEEPER_HPP
